#ifndef _CRC16_H_
#define _CRC16_H_

#include "ComTypes.h"

#define CRC16_POLY      0x8005U // "CRC-16": X**16 + X**15 + X**2 + X**0
#define CRC16_INIT      0x0000U // initial/start CRC16 value

#ifdef __cplusplus
extern "C" {
#endif

extern void CRC16_StartCalc   (uint16* pCRC16Value);

extern void CRC16_Calc        (uint16* pCRC16Value, const uint8* pDataBytes,
                               size_t DataBytesCount);

extern void CRC16_InitTable   (uint16 aCRC16Tab[0x100]);

extern void CRC16_CalcByTable (const uint16 aCRC16Tab[0x100], uint16* pCRC16Value,
                               const uint8* pDataBytes, size_t DataBytesCount);

extern void CRC16_FinishCalc  (uint16* pCRC16Value);

#ifdef __cplusplus
} // extern "C" {
#endif

#endif // _CRC16_H_
