#ifndef _UARTDRV_H_
#define _UARTDRV_H_

#include "Buffer.h"


class CUartDrv
{
public:
  CUartDrv();                   // default constructor
  virtual ~CUartDrv();          // default destructor

  int OpenPort (const char* pDeviceName, const DCB* pOpenDcb);
  int ClosePort();
  int IsPortOpen();

  int PutChar (unsigned char Char);
  int GetChar (unsigned char* pChar);

  void ClearRxBuffer();
  void ClearTxBuffer();

  CEvent& GetRxEvent();

protected:
  DCB dcb;

  int IsOpen;

  HANDLE CommHandle;

  COMMTIMEOUTS OriginalTimeouts;
  COMMTIMEOUTS NewTimeouts;

  CBuffer RxBuffer;
  CBuffer TxBuffer;

  CWinThread* pRxThread;
  CWinThread* pTxThread;

  CEvent QuitEvent;

  friend DWORD RxThreadFxn (LPVOID lParam);
  friend DWORD TxThreadFxn (LPVOID lParam);
};

#endif // _UARTDRV_H_
